using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Xamarin.Forms;
using Syncfusion.SfChart.XForms.Droid;
using Com.Syncfusion.Charts;
using Java.Util;

[assembly: ExportRenderer(typeof(SimpleSample.CustomChart), typeof(SimpleSample.Droid.CustomRenderer))]

namespace SimpleSample.Droid
{
    class CustomRenderer : SfChartRenderer
    {
        CustomChart chart;
        protected override void OnElementChanged(Xamarin.Forms.Platform.Android.ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);

            chart = e.NewElement as CustomChart;

            var nativeControl = Control;
            nativeControl.Behaviors.Remove(0);
            nativeControl.Behaviors.Add(new CustomTrackball());
            nativeControl.LabelsGenerated += nativeControl_LabelsGenerated;
        }

        void nativeControl_LabelsGenerated(object sender, Com.Syncfusion.Charts.SfChart.LabelsGeneratedEventArgs e)
        {
            IList<ChartPointInfo> infos = e.P1 as IList<ChartPointInfo>;
            Syncfusion.SfChart.XForms.ChartTrackballBehavior trackball = chart.ChartBehaviors[0] as Syncfusion.SfChart.XForms.ChartTrackballBehavior;
           // trackball.LabelStyle = new CustomChartTrackballLabelStyle();

            for (int i = 0; i < infos.Count; i++)
            {
                ChartPointInfo pointInfo = infos[i];
                String labelX = pointInfo.ChartDataPoint.GetX().ToString(); 
                String labelY = pointInfo.ChartDataPoint.GetY().ToString();
                pointInfo.Label = " Mon\n th: " + labelX + " \n Value: " + labelY;
            }
        }       
    }
}