﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Syncfusion.SfChart.XForms.WinPhone;
using Xamarin.Forms;
using Syncfusion.UI.Xaml.Charts;
using System.Text;
using System.Windows.Markup;
using Syncfusion.SfChart.XForms;
using System.Windows.Media;

[assembly: ExportRenderer(typeof(SimpleSample.CustomChart), typeof(SimpleSample.WinPhone.CustomRenderer))]
namespace SimpleSample.WinPhone
{
    public partial class MainPage : global::Xamarin.Forms.Platform.WinPhone.FormsApplicationPage
    {
        public MainPage()
        {
            InitializeComponent();
            SupportedOrientations = SupportedPageOrientation.PortraitOrLandscape;
            new CustomRenderer();
            global::Xamarin.Forms.Forms.Init();
            LoadApplication(new SimpleSample.App());
        }
    }

    public class LabelValueConverter : DependencyObject, System.Windows.Data.IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
             if (value == null)
                return String.Empty;

            ChartPointInfo pointInfo = value as ChartPointInfo;
            string label = " Month: " +pointInfo.ValueX + " \n Value: " + pointInfo.ValueY;

            return label;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }
   
    class CustomRenderer : SfChartRenderer
    {
        CustomChart chart;

        protected override void OnElementChanged(Xamarin.Forms.Platform.WinPhone.ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);
            chart = e.NewElement as CustomChart;

            ChartTrackballBehavior trackball = chart.ChartBehaviors[0] as ChartTrackballBehavior;

            ChartTrackBallBehavior nativeTrack = Control.Behaviors[0] as ChartTrackBallBehavior;
            nativeTrack.LabelHorizontalAlignment = ChartAlignment.Center;

            foreach (var item in Control.Series)
            {
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.Clear();

                stringBuilder.Append("<DataTemplate xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" ");
                stringBuilder.Append(" xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\"");
                stringBuilder.Append(" xmlns:labelConverter=\"clr-namespace:SimpleSample.WinPhone;assembly=SimpleSample.WinPhone\">");
                stringBuilder.Append("<Border Background=\"" + new SolidColorBrush(SfChartRenderer.GetWindowsColor(trackball.LabelStyle.BackgroundColor)).Color.ToString() + "\" >");
                stringBuilder.Append("<Border.Resources>");
                stringBuilder.Append("<labelConverter:LabelValueConverter  x:Key=\"track\"/>");
                stringBuilder.Append("</Border.Resources>");
                stringBuilder.Append("<TextBlock Text=\"{Binding Converter={StaticResource track}, ConverterParameter={StaticResource track}}\" />");
                stringBuilder.Append("</Border></DataTemplate>");

                item.TrackBallLabelTemplate = (System.Windows.DataTemplate)XamlReader.Load(stringBuilder.ToString());
            }
        }
    }
}
