﻿using System;

using Xamarin.Forms;
using System.Collections.Generic;
using Syncfusion.SfChart.XForms;
using System.Diagnostics;
using System.Collections.ObjectModel;

namespace SimpleSample
{
	public class SampleChart : ContentPage
	{
        ViewModel dataModel;

		public SampleChart ()
		{
			StackLayout layout = new StackLayout(){Padding = new Thickness(5,15,5,5)};						

			var chart = new CustomChart ();
            chart.PrimaryAxis = new CategoryAxis();
			chart.SecondaryAxis = new NumericalAxis ();

            dataModel = new ViewModel();
            dataModel.data = new List<MyModel>();
            dataModel.data.Add(new MyModel() { Name = "Jan", Value = 23 });
            dataModel.data.Add(new MyModel() { Name = "Feb", Value = 17 });
            dataModel.data.Add(new MyModel() { Name = "Mar", Value = 34 });
            dataModel.data.Add(new MyModel() { Name = "Apr", Value = 42 });
            dataModel.data.Add(new MyModel() { Name = "May", Value = 19 });

			ColumnSeries column = new ColumnSeries ();
            column.XBindingPath = "Name";
            column.YBindingPath = "Value";
            column.ItemsSource = dataModel.data ;	
				
			chart.VerticalOptions = LayoutOptions.FillAndExpand;
			chart.HorizontalOptions = LayoutOptions.FillAndExpand;

			chart.Series.Add(column);
				
            ChartTrackballBehavior trackBall = new ChartTrackballBehavior();
			trackBall.LabelStyle = new ChartTrackballLabelStyle { BackgroundColor = Color.FromRgb(124,149,161) };
            chart.ChartBehaviors.Add(trackBall);

			layout.Children.Add(chart);
			Content = layout;
		}
	}  
}


